/*
 * Header for config file parsing.
 *
 * This file should be included after stdio.
 *
 * Part of Chatserv, by Jonathan Lennox.  Written for no particularly good
 * reason, because I felt like it.  Allows multiple people to chat over the
 * net in a relatively straightforward environment.  Disclaimer: I figured out
 * how to do TCP/IP programming by reading man pages.
 *
 * Copyright 1995 Jonathan Lennox
 * Copyright 2017 Russ Allbery <eagle@eyrie.org>
 *
 * See LICENSE for licensing terms.
 */

#include <regex.h>

typedef enum {POSE_REGEX,
              DICE_REGEX,
              BAN_REGEX,
              BADNICK_REGEX,
              ALIAS_REGEX,
              NARRATE_REGEX,
              SPOOF_REGEX} regex_index;

extern const char *lookup_conf(const char *name);
extern const char *lookup_conf_no_error(const char *name);
extern const char *lookup_conf_with_numeric(const char *name, int *numeric);
extern const char *lookup_conf_with_fallback(const char *name,
                                             const char *fallback);
extern int set_conf(const char *name, const char *val);

extern int load_config(void);

extern const char *get_conf_client_chars(void);
extern regex_t *get_conf_regex(regex_index index);

/* Commands */

int reload_cmd(const char *cmd_name, struct connection *user, char *args);
