/*
 * Header file for dynamic strings.
 *
 * Part of Chatserv, by Jonathan Lennox.  Written for no particularly good
 * reason, because I felt like it.  Allows multiple people to chat over the
 * net in a relatively straightforward environment.  Disclaimer: I figured out
 * how to do TCP/IP programming by reading man pages.
 *
 * Copyright 1995 Jonathan Lennox
 *
 * See LICENSE for licensing terms.
 */

typedef struct {
  char *buf; /* The buffer in question */
  char *pos; /* The null at the end of the buffer. */
  int len;   /* The current length of the buffer. */
} dyn_string;

#define DYN_STR_INIT(len) {NULL, NULL, len}

dyn_string *dyn_strcat(dyn_string *dest, const char *src);
dyn_string *dyn_strcpy(dyn_string *dest, const char *src);
