/* Modified 1996 by Jonathan Lennox for inclusion in Calvin.
   You are free to use this source under the terms of the LGPL, of course,
   but I recommend you go to either GNU libc or Linux libc for an
   unhacked-upon version of this file.

   Derived from Linux <search.h>.  I've taken out things like non-ANSI-ness,
   other search functions referenced, etc, and also modified things so
   you can have multiple hashes at once (so we're no longer SVID-complient).
*/

/* Copyright (C) 1993 Ulrich Drepper

This file is intended to be included in the GNU C Library and the
Linux C Library. So the copyright notice will be:


Copyright (C) 1993 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.


For now the file can be distributed under the LGPL.  */

#ifndef _HSEARCH_H
#define _HSEARCH_H

/* for use with hsearch */

typedef struct entry { char *key; char *data; } ENTRY;
typedef struct { int used; ENTRY entry; } _ENTRY;

typedef enum { FIND, ENTER } ACTION;

struct hsearch_data { _ENTRY * htable; unsigned hsize; unsigned filled; };


extern ENTRY * hsearch(ENTRY, ACTION, struct hsearch_data *);
extern int     hcreate(unsigned, struct hsearch_data *);
extern void    hdestroy(struct hsearch_data *);

#endif /* hsearch.h */
