/*
 * Prototypes and data structures for configuration file lexing.
 *
 * Part of Chatserv, by Jonathan Lennox.  Written for no particularly good
 * reason, because I felt like it.  Allows multiple people to chat over the
 * net in a relatively straightforward environment.  Disclaimer: I figured out
 * how to do TCP/IP programming by reading man pages.
 *
 * Copyright 1995 Jonathan Lennox
 *
 * See LICENSE for licensing terms.
 */

#include <regex.h>

#include "hsearch.h"

#define REGEX_COUNT 7

struct configuration {
  char *data;
  char *data_ptr;
  char *data_end;
  size_t data_size;

  struct value *values;
  struct value *value_ptr;
  struct value *values_end;
  size_t value_table_size;

  struct hsearch_data *htab;

  regex_t regexps[REGEX_COUNT];

  char client_chars[5];
};

extern const char *lookup_conf_in_config(const char *name,
                                         struct configuration *conf);
extern int set_conf_in_config(const char *name, const char *val,
                              struct configuration *conf);

extern int scan_config(FILE *config_file, struct configuration *conf);
