/*
 * Prototypes for TLS handling.
 *
 * Part of Chatserv, by Jonathan Lennox.  Written for no particularly good
 * reason, because I felt like it.  Allows multiple people to chat over the
 * net in a relatively straightforward environment.  Disclaimer: I figured out
 * how to do TCP/IP programming by reading man pages.
 *
 * Copyright 2005 Matthew Gerber
 * Copyright 2017 Russ Allbery <eagle@eyrie.org>
 *
 * See LICENSE for licensing terms.
 */

#ifdef DO_SSL
#define GNUTLS11
#endif

#ifdef GNUTLS11
#include <gnutls/gnutls.h>
#define SSL gnutls_session_t
#endif

#ifndef DO_SSL
#define SSL int
#endif

void ssl_init(void);
void ssl_end(SSL);
int ssl_write(SSL, char *, int);
int ssl_read(SSL, char *, int);
struct connection *start_ssl_setup(struct connection *, int fd);
void continue_ssl_setup(struct connection *);
